"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MockApp = void 0;
const auth_1 = require("../auth");
const firestore_1 = require("../firestore");
class MockApp {
    constructor(name, options = {}) {
        this.name = name;
        this.options = options;
    }
    analytics() {
        throw new Error("Not implemented");
    }
    auth() {
        this.authInstance = this.authInstance || new auth_1.MockAuth(this);
        return this.authInstance;
    }
    database() {
        throw new Error("Not implemented");
    }
    delete() {
        throw new Error("Not implemented");
    }
    firestore() {
        this.firestoreInstance = this.firestoreInstance || new firestore_1.MockFirestore(this);
        return this.firestoreInstance;
    }
    functions() {
        throw new Error("Not implemented");
    }
    installations() {
        throw new Error("Not implemented");
    }
    messaging() {
        throw new Error("Not implemented");
    }
    performance() {
        throw new Error("Not implemented");
    }
    remoteConfig() {
        throw new Error("Not implemented");
    }
    storage() {
        throw new Error("Not implemented");
    }
}
exports.MockApp = MockApp;
//# sourceMappingURL=app.js.map