import * as firebase from "firebase";
import { MockApp } from "../app";
import { SocialSignInMock } from "./social-signin-mock";
import { User } from "./user";
import { UserStore } from "./user-store";
export declare type AuthStateChangeListener = (user: firebase.User | null) => void;
export declare class MockAuth implements firebase.auth.Auth {
    readonly app: MockApp;
    currentUser: User | null;
    languageCode: string | null;
    settings: firebase.auth.AuthSettings;
    tenantId: string | null;
    readonly store: UserStore;
    private readonly authStateEvents;
    constructor(app: MockApp);
    applyActionCode(code: string): Promise<any>;
    checkActionCode(code: string): Promise<any>;
    confirmPasswordReset(code: string, newPassword: string): Promise<any>;
    createUserWithEmailAndPassword(email: string, password: string): Promise<firebase.auth.UserCredential>;
    fetchSignInMethodsForEmail(email: string): Promise<string[]>;
    getRedirectResult(): Promise<any>;
    isSignInWithEmailLink(emailLink: string): boolean;
    mockSocialSignIn(provider: firebase.auth.AuthProvider): SocialSignInMock;
    onAuthStateChanged(nextOrObserver: AuthStateChangeListener, error?: (a: firebase.auth.Error) => void, completed?: firebase.Unsubscribe): firebase.Unsubscribe;
    onIdTokenChanged(nextOrObserver: firebase.Observer<any, any> | ((a: firebase.User | null) => void), error?: (a: firebase.auth.Error) => void, completed?: firebase.Unsubscribe): firebase.Unsubscribe;
    sendPasswordResetEmail(email: string, actionCodeSettings?: firebase.auth.ActionCodeSettings | null): Promise<any>;
    sendSignInLinkToEmail(email: string, actionCodeSettings: firebase.auth.ActionCodeSettings): Promise<void>;
    setPersistence(persistence: string): Promise<void>;
    private signIn;
    private signInWithSocial;
    signInAndRetrieveDataWithCredential(credential: firebase.auth.AuthCredential): Promise<any>;
    signInAnonymously(): Promise<firebase.auth.UserCredential>;
    signInWithCredential(credential: firebase.auth.AuthCredential): Promise<any>;
    signInWithCustomToken(token: string): Promise<any>;
    signInWithEmailAndPassword(email: string, password: string): Promise<firebase.auth.UserCredential>;
    signInWithEmailLink(email: string, emailLink?: string | undefined): Promise<firebase.auth.UserCredential>;
    signInWithPhoneNumber(phoneNumber: string, applicationVerifier: firebase.auth.ApplicationVerifier): Promise<any>;
    signInWithPopup(provider: firebase.auth.AuthProvider): Promise<firebase.auth.UserCredential>;
    signInWithRedirect(provider: firebase.auth.AuthProvider): Promise<void>;
    signOut(): Promise<void>;
    updateCurrentUser(user: firebase.User | null): Promise<void>;
    useDeviceLanguage(): void;
    verifyPasswordResetCode(code: string): Promise<any>;
}
