import * as firebase from "firebase";
import { MockFirestore } from "./firestore";
import { MockQuery } from "./query";
import { MockDocumentReference } from "./document-reference";
export declare class MockCollectionReference<T = firebase.firestore.DocumentData> extends MockQuery<T> implements firebase.firestore.CollectionReference<T> {
    readonly id: string;
    readonly parent: MockDocumentReference | null;
    readonly converter: firebase.firestore.FirestoreDataConverter<T>;
    constructor(firestore: MockFirestore, id: string, parent: MockDocumentReference | null, converter: firebase.firestore.FirestoreDataConverter<T>);
    doc(documentPath?: string | undefined): MockDocumentReference<T>;
    add(data: T): Promise<MockDocumentReference<T>>;
    isEqual(other: firebase.firestore.CollectionReference<T>): boolean;
    withConverter<U>(converter: firebase.firestore.FirestoreDataConverter<U>): MockCollectionReference<U>;
}
