import * as firebase from "firebase";
import { MockFirestore } from "./firestore";
import { MockDocumentReference } from "./document-reference";
import { MockDocumentSnapshot } from "./document-snapshot";
export declare class MockTransaction implements firebase.firestore.Transaction {
    private readonly firestore;
    private readonly operations;
    private readonly affectedDocs;
    private readonly surrogateFirestore;
    constructor(firestore: MockFirestore);
    get<T>(documentRef: MockDocumentReference<T>): Promise<MockDocumentSnapshot<T>>;
    set<T>(documentRef: firebase.firestore.DocumentReference<T>, data: T, options?: firebase.firestore.SetOptions | undefined): firebase.firestore.Transaction;
    update(documentRef: firebase.firestore.DocumentReference<any>, data: firebase.firestore.UpdateData): firebase.firestore.Transaction;
    update(documentRef: firebase.firestore.DocumentReference<any>, field: string | firebase.firestore.FieldPath, value: any, ...moreFieldsAndValues: any[]): firebase.firestore.Transaction;
    delete(documentRef: firebase.firestore.DocumentReference<any>): firebase.firestore.Transaction;
    commit(): Promise<void>;
}
