"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventEmitter = void 0;
class EventEmitter {
    constructor() {
        this.listeners = {};
    }
    hasListeners(event) {
        return this.listeners[event] && this.listeners[event].length > 0;
    }
    off(event, listener) {
        this.listeners[event] = (this.listeners[event] || []).filter((item) => item !== listener);
    }
    on(event, listener) {
        this.listeners[event] = this.listeners[event] || [];
        this.listeners[event].push(listener);
    }
    emit(event, args = []) {
        (this.listeners[event] || []).forEach((listener) => {
            listener(...args);
        });
    }
}
exports.EventEmitter = EventEmitter;
//# sourceMappingURL=event-emitter.js.map